/* hash.h
 * Implantation d'une table de double de hachage
 * pour enregistrer des noms avec des dates de naissance
 * Auteur : VOURIOT Thierry
 * Date : 15 decembre 2001
 */

#include "convert.h"
#include <math.h>


/* Taille de la table M = 2^3 */
#define M 8 

/* Structure des enregistrements */
typedef struct Pers{
	char nom[20];
	int naissance;
	Nat etat; /* 0=libre 1=ocuppe 2=vide */
} Personne, *Table;

/* Fonction de hachage */
extern BNat h(BNat);

/* Deuxieme fonction de hachage de type modulo */
extern BNat pprim(BNat);
extern BNat pp(BNat);

/* Creation d'une nouvelle table */
extern Table tablenouv(void);

/* Adjonction d'une entree dans la table 
 * pre adj(t,i,x) = (elem(t,i)== et x!=)
 */
extern Table adj(Table, char *,int date);

/* Affichage de la table */
extern void aff(Table);

/* Date de naissance en fonction d'un nom */
extern int elem(Table, char *);

/* Suppression d'une entree dans la table */
extern Table supp(Table, char *);

